const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TemplatesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const templates = await db.templates.create(
      {
        id: data.id || undefined,

        key: data.key || null,
        name: data.name || null,
        variant: data.variant || null,
        colors: data.colors || null,
        is_premium: data.is_premium || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await templates.setOrganizations(data.organizations || null, {
      transaction,
    });

    return templates;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const templatesData = data.map((item, index) => ({
      id: item.id || undefined,

      key: item.key || null,
      name: item.name || null,
      variant: item.variant || null,
      colors: item.colors || null,
      is_premium: item.is_premium || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const templates = await db.templates.bulkCreate(templatesData, {
      transaction,
    });

    // For each item created, replace relation files

    return templates;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const templates = await db.templates.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.key !== undefined) updatePayload.key = data.key;

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.variant !== undefined) updatePayload.variant = data.variant;

    if (data.colors !== undefined) updatePayload.colors = data.colors;

    if (data.is_premium !== undefined)
      updatePayload.is_premium = data.is_premium;

    updatePayload.updatedById = currentUser.id;

    await templates.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await templates.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return templates;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const templates = await db.templates.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of templates) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of templates) {
        await record.destroy({ transaction });
      }
    });

    return templates;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const templates = await db.templates.findByPk(id, options);

    await templates.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await templates.destroy({
      transaction,
    });

    return templates;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const templates = await db.templates.findOne({ where }, { transaction });

    if (!templates) {
      return templates;
    }

    const output = templates.get({ plain: true });

    output.profile_pages_theme_template =
      await templates.getProfile_pages_theme_template({
        transaction,
      });

    output.organizations = await templates.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.key) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('templates', 'key', filter.key),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('templates', 'name', filter.name),
        };
      }

      if (filter.colors) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('templates', 'colors', filter.colors),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.variant) {
        where = {
          ...where,
          variant: filter.variant,
        };
      }

      if (filter.is_premium) {
        where = {
          ...where,
          is_premium: filter.is_premium,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.templates.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('templates', 'name', query),
        ],
      };
    }

    const records = await db.templates.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
